﻿package  
{
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import mx.collections.ArrayCollection;
	import mx.containers.Canvas;
	import mx.containers.dividedBoxClasses.BoxDivider;
	import mx.controls.Label;
	import mx.controls.ProgressBar;
	import mx.controls.ProgressBarDirection;
	import mx.core.*;
	import mx.controls.Image;
	import mx.events.DragEvent;	
	import Visual.*;
	
	/**
	 * ...
	 * @author Nicki Thomas Hansen
	 */
	public class Controller 
	{
		protected static var instance:Controller = null;
		private var machines:ArrayCollection = new ArrayCollection();
		private var newMachines:ArrayCollection = new ArrayCollection();
		private var removedMachines:ArrayCollection = new ArrayCollection();
		private var lastFrame:Date;
		private var pulseTime:Number = new Number(0);
		private var pulseInterval:Number = new Number(1);
		public var currentlySelectedMachine:Machine;
		private var gameStarted:Boolean = false;
		private var timeToUpdateMachine:Number = 1;
		private var currentMachineTime:Number = 0;
		private var drawingline:Boolean = false;
		private var connectionMode:Boolean = false;
		private var connectInput:Boolean = false;
		public var input:InputMachine;
		public var output:OutputMachine;
		public var model:Model;
		
		
		
		
		static public function get Instance():Controller
		{
			if ( instance == null )
				instance = new Controller();
			return instance;
		}
		
		public function Controller() 
		{
			if ( instance != null )
				throw new Error( "Only one Singleton instance should be instantiated" ); 
		}
		
		
		public function startGame(event:Event):void
		{
			gameStarted = true;
			model = new Model();
			input = new InputMachine();
			input.sprite.move(0, 150);
			addGameSprite(input.sprite);
			output = new OutputMachine();
			var startX:Number = Application.application.gameCanvas.width - output.sprite.width;
			var starty:Number = 150
			output.sprite.move(startX, starty);
			addGameSprite(output.sprite);
			
		}
		
		public function sellMachine(machine:Machine):void
		{
			model.sellMachine(machine.sellMachineAmount);
			removeMachine(machine);
			Application.application.machineOptions.visible = false;	
			redrawConnections();
		}
		
		public function addNewMachine(event:Event, stage:Number, taste:Number):Machine
		{
			//taste == type
			// skal måske være true (selected)
			var machine:Machine = new Machine(taste, stage, false);
			newMachines.addItem(machine);			
			return machine;
		}
		/**
		 * Removes a machine from the model, and the associated gamesprite from gameCanvas.
		 * @param	machine
		 */
		public function removeMachine(machine:Machine):void
		{
			removedMachines.addItem(machine);
		}

		
		public function enterFrame(event:Event):void
		{
			// Calculate the time since the last frame
			if (lastFrame == null) lastFrame = new Date();
			var thisFrame:Date = new Date();
			var seconds:Number = (thisFrame.getTime() - lastFrame.getTime()) / 1000.0;
			
			
			updateMachines(seconds);
			lastFrame = thisFrame;
			
	    	removeDeletedMachines();
			insertNewMachines();
			
			updatePointLabels();
			
		}
		//gameClick
		public function selector(event:Event):void
		{	
			connectionMode = false;
			if (gameStarted) deselectAll();
			if (event.target != Application.application.gameCanvas 
			&& event.target != Application.application.btnStart)
			{
				var sprite:GameSprite = GameSprite(event.target);				
				
				if (sprite.isInput)
				{
					//do input
					Application.application.inputOptions.visible = true;
					
				}
				else if (sprite.isOutput)
				{
					//output?
				}				
				else
				{
					for each (var machine:Machine in machines)
					{
						
						if (machine.sprite == sprite)
						{							
							//select
							sprite.changeSelection(true);
							currentlySelectedMachine = machine;
							//upgrade button visible
							if (currentlySelectedMachine.locked)
							{
								Application.application.machineOptions.visible = true;
								updateLabels();								
								
							}else 
							{
								Application.application.buyOptions.visible = true;
							}
							break;
						} 
					}
				}
				
			}					
		}
		

		
		public function selectThis(machine:Machine):void
		{
			deselectAll();
			currentlySelectedMachine = machine;
			updateLabels();
			currentlySelectedMachine.sprite.changeSelection(true);
			Application.application.buyOptions.visible = true;
			Application.application.buildBtn.enabled = false;
		}
		//connect labels with machine
		public function updateLabels():void
		{
			/*
			 * valueAddedLabel
			 * outputLabel
			 * speedSlider
			 */
			
			Application.application.outputLabel.text = currentlySelectedMachine.speed + " units";
			Application.application.speedSlider.value = currentlySelectedMachine.speedPercentage;
			Application.application.machineName.text = currentlySelectedMachine.name;
			// upgrade, sell (build in buildClicked)
			if (currentlySelectedMachine.isMaxLevel())
			{
				Application.application.upgradeBtn.label = "Fully upgraded";
				Application.application.upgradeBtn.enabled = false;
			}
			else 
			{
				Application.application.upgradeBtn.label = "Upgrade ($" + currentlySelectedMachine.getUpgradeCost() + ")";
				Application.application.upgradeBtn.enabled = true;
			}
			
			Application.application.buildBtn.label = "Build ($" + currentlySelectedMachine.buildMachineCost + ")";
			Application.application.sellBtn.label = "Sell ($" + currentlySelectedMachine.sellMachineAmount + ")";
			Application.application.maintenanceLabel.text = currentlySelectedMachine.maintenanceCost;
			
		}
		
		
		//upgradeclick
		public function upgradeMachine(event:Event):void
		{
			if (currentlySelectedMachine != null)
			{
				if (model.isPaymentPossible(currentlySelectedMachine.getUpgradeCost()))
				{
					model.doPayment(currentlySelectedMachine.getUpgradeCost());
					currentlySelectedMachine.upgrade();
				}
				
			}
		}
		
		
		/*********************************************
		 * private funktioner
		 */
		
		private function insertNewMachines():void
		{
			for each (var machine:Machine in newMachines)
			{
				machines.addItem(machine);
				machine.setOutputBay(output);
				addGameSprite(machine.sprite);
			}
			newMachines.removeAll();
		}
		
		private function removeDeletedMachines():void
		{	
			//remove the machine
			for each (var removedMachine:Machine in removedMachines)
			{
				removeConnections(removedMachine);
				removedMachine.forwardConnections.removeAll();
				var i:int = 0;
				for (i; i < machines.length; i++)
				{
					if (machines.getItemAt(i) == removedMachine)
					{
						//removeConnections(Machine(machines.getItemAt(i)));
						removeGameSprite(machines.getItemAt(i).sprite);
						machines.removeItemAt(i);						
						break; 
					}
				}
			}
			removedMachines.removeAll();
			redrawConnections();
		}
		//remove connections to this machine
		private function removeConnections(removedMachine:Machine):void
		{
			//find the connections to this and remove
			//virker ikke
			for each (var machineInGame:Machine in machines)
			{
				for (var i:int = 0; i < machineInGame.forwardConnections.length; i++) 
				{
					if (machineInGame.forwardConnections.getItemAt(i) == removedMachine)
					{
						machineInGame.forwardConnections.removeItemAt(i);
						i--;
					}
					
				}
			}
			
			for (var j:int = 0; j < input.connectedTo.length; j++) 
			{
				if (input.connectedTo.getItemAt(j) == removedMachine)
				{
					input.connectedTo.removeItemAt(j);
					j--;
				}					
			}
			
			
			redrawConnections();
		}
		
		
		//
		private function updateMachines(seconds:Number):void
		{
			currentMachineTime += seconds;
			
			if (currentMachineTime >= 1)
			{
				Application.application.incomeLabel.htmlText = '(<font color="#44FF44">+' + model.incomePerSec + '</font> / ' + 
				'<font color="#FF4444">-' + model.costPerSec + '</font>)';
				
				
				model.resetIncomePerSec();
				model.resetCostPerSec();
			}
			
			if (currentMachineTime >= timeToUpdateMachine)
			{
				var beerPrices:Number = input.generateBeers(model.money);
				model.doPayment(beerPrices);
				Application.application.resourcesLeft.text = "Resources left for " + input.finiteAmountOfBeer + " beers";
				//do update
				for each (var machine:Machine in machines)
				{
					
					if (machine.locked)
					{						
						if (model.isPaymentPossible(machine.maintenanceCost))
						{
							model.doPayment(machine.maintenanceCost);
							machine.processBeer();
						}
						else
						{
							//TODO errormessage cost too high, sent un-processed evt. til output?
						}
					}
				}
				
				for each (var machine2:Machine in machines)
				{
					//divide in: process, send
					if (machine2.locked) machine2.sendBeer();
				}
				//				
				
				//model.addIncome(output.sellBeers());
				
				currentMachineTime = 0;
				
			}
			
			
			
			model.addIncome(output.sellBeer());
			
		}
		
		private function updatePointLabels():void
		{
			Application.application.netWorthLabel.text = String(model.netWorth);
			Application.application.moneyLabel.text = String(model.money);
		}
		
		
		private function addGameSprite(image:GameSprite):void 
		{	
			
			image.addEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			image.addEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);
			
			Application.application.gameCanvas.addChild(image);
		}
		private function removeGameSprite(image:GameSprite):void 
		{	
			
			image.removeEventListener(MouseEvent.MOUSE_DOWN, mouseDownHandler);
			image.removeEventListener(MouseEvent.MOUSE_UP, mouseUpHandler);			
			Application.application.gameCanvas.removeChild(image);
		}
		

		private function deselectAll():void
		{
			if (currentlySelectedMachine != null)
			{
				currentlySelectedMachine.sprite.changeSelection(false);
			}
			else 
			{
				for each (var machine:Machine in machines)
				{
					machine.sprite.changeSelection(false);
				}
				
			}
			currentlySelectedMachine = null;
			Application.application.inputOptions.visible = false;
			Application.application.machineOptions.visible = false;
			Application.application.buyOptions.visible = false;
			Application.application.upgradeBtn.visible = true; //hack ;)
		}
		
		public function outOfResources():void
		{
			trace("Out of resources");
			endGame();
		}
		
		public function outOfMoney():void
		{
			trace("Out of money");
			loseGame();
		}
		
		private function loseGame():void
		{
			Application.application.currentState = "EndGame";
			Application.application.finalScore.text = "You lost!";
		}
		
		public function endGame():void
		{
			
			Application.application.currentState = "EndGame";
			Application.application.finalScore.text = "Your final score is " + model.money + ".";
		}
		
		/************************************************
		 * Event Handlers 
		 */
		private function mouseDownHandler(event:MouseEvent):void 
		{
			
			
			if (connectionMode)
			{
				if (connectInput || event.target == input.sprite) connectInputToMachine(event);
				else connectMachineToMachine(event);
			}
			
			///////
			
			if (currentlySelectedMachine == null)
			{
				selector(event);
			} else if (currentlySelectedMachine.sprite != event.target)
			{
				selector(event);
			}
			if (!GameSprite(event.target).locked)
			{
				var sprite:Image = Image(event.target);			
			
				sprite.startDrag(false, new Rectangle(0, 0, Application.application.gameCanvas.width - sprite.width, Application.application.gameCanvas.height - sprite.height));
			}			
		}
		
		private function connectMachineToMachine(event:MouseEvent):void
		{			
			
			var machine1:Machine = currentlySelectedMachine;
			selector(event);
			if (currentlySelectedMachine != null)
			{	
				if (currentlySelectedMachine.locked)
				{
					var machine2:Machine = currentlySelectedMachine;
			
					machine1.connectTo(machine2);
					//drawConnection(machine1.sprite.x + 40, machine1.sprite.y + 40, machine2.sprite.x + 40, machine2.sprite.y + 40);
					redrawConnections();
				}
			}
			connectionMode = false;
		}
		
		private function connectInputToMachine(event:MouseEvent):void
		{
			var machine:Machine;
			//machine -> input
			if (event.target == input.sprite)
			{
				if (currentlySelectedMachine != null)
				{
					if (currentlySelectedMachine.stage == 0)
					{
						input.addConnection(currentlySelectedMachine);
						machine = currentlySelectedMachine;
					}
				}
			}
			else 
			{
				selector(event);
				if (currentlySelectedMachine != null)
				{
					if (currentlySelectedMachine.locked)
					{
						if (currentlySelectedMachine.stage == 0)
						{
							machine = currentlySelectedMachine;
							input.addConnection(machine);
						}
				
					}
				}
			}
			if (machine != null) 
			{
				/*
				var inX:Number = input.sprite.x + input.sprite.width;
				var inY:Number = input.sprite.y + Math.ceil(input.sprite.height / 2);
				drawConnection(inX, inY, machine.sprite.x + 40, machine.sprite.y + 40);
				*/
				
				redrawConnections();
			}

			connectionMode = false;
			connectInput = false;
		}
		
		public function redrawConnections():void
		{
			Application.application.gameCanvas.graphics.clear();			
			var inX:Number = input.sprite.x + Math.ceil(input.sprite.width / 2);
			var inY:Number = input.sprite.y + Math.ceil(input.sprite.height / 2);
			var outX:Number = output.sprite.x + Math.ceil(output.sprite.width / 2);
			var outY:Number = output.sprite.y + Math.ceil(output.sprite.height / 2);
			
			
			for each (var machineIn:Machine in input.connectedTo)
			{				
				drawConnection(inX, inY, machineIn.sprite.x + Math.round(machineIn.sprite.width / 2), machineIn.sprite.y + Math.round(machineIn.sprite.height / 2));
				
			}
			for each (var machine:Machine in machines) 
			{
				for each (var machineConnection:Machine in machine.forwardConnections) 
				{
					drawConnection(machine.sprite.x + Math.round(machine.sprite.width / 2), machine.sprite.y + Math.round(machine.sprite.height / 2), 
					machineConnection.sprite.x + Math.round(machineConnection.sprite.width / 2), machineConnection.sprite.y + Math.round(machineConnection.sprite.height / 2));
				}
				if (machine.forwardConnections.length == 0)
				{
					drawConnection(machine.sprite.x + Math.round(machine.sprite.width / 2), machine.sprite.y + Math.round(machine.sprite.height / 2), outX, outY);
				}
				
			}			
		}
		
		//change to redraw, which gets the coords from machines
		private function drawConnection(x1:Number, y1:Number, x2:Number, y2:Number):void
		{
			var canvas:Canvas = Application.application.gameCanvas;			
			canvas.graphics.lineStyle(10, 0xaaaaaa);
			canvas.graphics.moveTo(x1, y1);
			canvas.graphics.lineTo(x2, y2);
			//TODO insert objects flowing along the lines
			
		}
		
		public function enterConnectionMode():void
		{
			connectionMode = true;
			//drawline
		}
		public function setConnectInput():void
		{			
			connectInput = true;
		}

		
	    private function mouseUpHandler(event:MouseEvent):void 
		{
			
			var sprite:Image = Image(event.target);
			sprite.stopDrag();
			//check for goodX, goodY
			if (goodCoordinate(sprite.x, sprite.y, sprite))
			{
				Application.application.buildBtn.enabled = true;
			}
			else Application.application.buildBtn.enabled = false;
			
			
			
		}
		//--
		private function goodCoordinate(x:Number, y:Number, sprite:Image):Boolean
		{	
			if (x - 5 < 0) return false;
			if (y - 5 < 0) return false;
			if (x + sprite.width + 5 > Application.application.gameCanvas.width) return false;
			if (y + sprite.height + 5 > Application.application.gameCanvas.height) return false;
			
			for each (var machine:Machine in machines)
			{
				if (machine.sprite != sprite)
				{
					if (sprite.hitTestObject(machine.sprite)) return false;
				}
			}			
			if (sprite.hitTestObject(input.sprite)) return false;
			if (sprite.hitTestObject(output.sprite)) return false;
			
			return true;
		}
	}	
}