﻿package  
{
	import flash.system.IMEConversionMode;
	import mx.collections.ArrayCollection;
	
	import Visual.GameSprite;
	
	/**
	 * ...
	 * @author Nicki Thomas Hansen
	 */
	public class Machine 
	{
		public var sprite:GameSprite;
		public var locked:Boolean;
		//public var nextMachine:Machine;
		public var forwardConnections:ArrayCollection = new ArrayCollection();
		//public var prevMachine:Machine;
		
		private var incomingBeers:ArrayCollection = new ArrayCollection();		
		private var outgoingBeers:ArrayCollection = new ArrayCollection();
		public var name:String;
		public var speedConstant:Number;
		public var speed:Number;
		public var speedPercentage:Number;
		
		private var upgradeLevel:Number;
		
		//values
		public var stage:Number;
		public var sellMachineAmount:Number;
		public var buildMachineCost:Number; //skal bruges her, da den alligevel bliver lavet naar man vil placere
		public var upgradeMachineCost:Array;
		public var upgradeValues:Array;
		public var maintenanceConstant:Number;
		public var maintenanceCost:Number;
		
		//temp outputMachine
		public var inputConnection:InputMachine;
		public var outputBay:OutputMachine;
		
		//temp?, change to proper Beer DNA
		//public var addedValue:Number;
		//public var soldBeerValue:Number = 0;
		//tastes
		public var bitter:Number = 0;
		public var salty:Number = 0;
		public var sour:Number = 0;
		public var sweet:Number = 0;
		public var umami:Number = 0;
		
		public var quality:Array;
		
		 
		public function Machine(taste:Number, stage:Number, selected:Boolean)
		{
			sprite = new GameSprite(taste, stage, selected);
			sprite.setStartPosition(650, 500);
			locked = false;
			
			
			//based on which machine it is
			determineSettings(taste, stage);
			//addedValue = 1;
			speedConstant = 0.2;
			speedPercentage = 100;
			updateSpeed(speedPercentage);
			upgradeLevel = 1;
			upgradeMachineCost = [250, 500, 500, 600]; //temp!			
			quality = [1, 1.2, 1.4, 1.7, 2, 2.4]
			buildMachineCost = 100;
			sellMachineAmount = Math.round(buildMachineCost / 2);
			maintenanceCost = Math.ceil(maintenanceConstant * speedPercentage);
		}
		
		public function enterFrame(seconds:Number):void
		{
			
		}
		
		public function getUpgradeCost():Number
		{			
			return upgradeMachineCost[upgradeLevel - 1];			
		}
		public function upgrade():void
		{
			sprite.upgrade();
			//TODO UpgradeStuff
			sellMachineAmount += Math.round(upgradeMachineCost [upgradeLevel - 1] / 2);
			upgradeLevel++;
		}
		public function isMaxLevel():Boolean
		{
			if (upgradeLevel >= 5) return true;
			return false;
		}
		
		public function lock():void
		{
			locked = true;			
			sprite.lock();
		}
		public function connectTo(machine:Machine):void
		{
			//forward
			if (machine.stage == stage +1)
			{
				forwardConnections.addItem(machine);
				
				
			}
			//backward
			if (machine.stage == stage -1)
			{
				machine.forwardConnections.addItem(this);
			}
		}
		
		public function hasConnections():Boolean
		{
			if (forwardConnections.length == 0) return true;
			return false;
		}
		
		public function setOutputBay(output:OutputMachine):void
		{
			outputBay = output;			
		}
				
		public function updateSpeed(percentage:Number):void
		{
			speedPercentage = percentage;
			speed = Math.round(speedConstant * speedPercentage);
			//TODO maintenancecost determined by speed/constant?.
			maintenanceCost = Math.ceil(maintenanceConstant * speedPercentage);
			
		}

		//addbeer, sendbeer?
		public function processBeer():void
		{			
			/*
			for each (var beer:Beer in incomingBeers)
			{
				beer.value += addedValue;
				//trace("beer value: " + beer.value);
				outgoingBeers.addItem(beer);
			}
			incomingBeers.removeAll();
			*/
			
			for each (var beer:Beer in incomingBeers)
			{
				beer.addTastes(bitter, salty, sour, sweet, umami);
				if (this.isMaxLevel()) beer.addQuality(quality[4]);
				else beer.addQuality(quality[upgradeLevel]);
				beer.completedStage = stage + 1; //for average qual
				outgoingBeers.addItem(beer);
			}
			incomingBeers.removeAll();
			
		}
		
		public function sendBeer():void
		{
			if (locked)
			{	
				var output:Number = speed;	
				
				var numberOfConnects:Number = forwardConnections.length;
				var cursor:Number = 0;
				
				while (output != 0 && outgoingBeers.length != 0)
				{
					if (numberOfConnects == 0)
					{
						outputBay.addBeer(Beer(outgoingBeers.getItemAt(0)));
					}
					else 
					{
						if (numberOfConnects <= cursor)
						{
							cursor = 0;
						}
						Machine(forwardConnections.getItemAt(cursor)).addBeer(Beer(outgoingBeers.getItemAt(0)));
						cursor++;
					}
					outgoingBeers.removeItemAt(0);				
					output--;
				}
			}			
		}				

		
		public function addBeer(beer:Beer):void
		{
			incomingBeers.addItem(beer);
		}
		
		
		/* 
		 * input med while (så længe der er plads i maskinen, og nye materialer fra previous)
		 *  pr. sekund
		 * beregn værdimodifikation, dna etc.
		 * send videre til næste i linien eller sælg
		 * 
		 * */
		
		 private function determineSettings(taste:Number, stage:Number):void
		{	
			//general for all
			this.stage = stage;
			
			if (taste == 0) //bitter
				{
					name = "Bitter";
					bitter = 1;
				}
				else if (taste == 1) //salty
				{	
					name = "Salty";
					salty = 1;					
				}
				else if (taste == 2) //sour
				{				
					name = "Sour";
					sour = 1;
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet";
					sweet = 1;
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami";
					umami = 1;
				}
			if (stage == 0) // Mill
			{
				name += " Mill";
				maintenanceConstant = 0.1;
			} 
			else if (stage == 1) // Masher
			{
				name += " Masher";
				maintenanceConstant = 0.15;
			}
			else if (stage == 2) // Lauter
			{
				name += " Lauter";
				maintenanceConstant = 0.1;
			}
			else if (stage == 3) // Boiler
			{
				name += " Boiler";
				maintenanceConstant = 0.3;
			}
			else if (stage == 4) // Fermenter
			{
				name += " Fermenter";
				maintenanceConstant = 0.15;
			}
			else if (stage == 5) // Bottler
			{
				name += " Bottler";
				maintenanceConstant = 0.4;
			}
			
			
			/*
			//specific
			if (stage == 0) // Mill
			{
				if (taste == 0) //bitter
				{
					name = "Bitter Mill";
					bitter = 1;
				}
				else if (taste == 1) //salty
				{	
					name = "Salty Mill";	
					
				}
				else if (taste == 2) //sour
				{				
					name = "Sour Mill";
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet Mill";
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami Mill";
				}
			} 
			else if (stage == 1) // Masher
			{
				if (taste == 0) //bitter
				{				
					name = "Bitter Masher";
				}
				else if (taste == 1) //salty
				{				
					name = "Salty Masher";
				}
				else if (taste == 2) //sour
				{				
					name = "Sour Masher";
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet Masher";
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami Masher";
				}
			}
			else if (stage == 2) // Lauter
			{
				if (taste == 0) //bitter
				{				
					name = "Bitter Lauter";
				}
				else if (taste == 1) //salty
				{				
					name = "Salty Lauter";
				}
				else if (taste == 2) //sour
				{				
					name = "Sour Lauter";
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet Lauter";
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami Lauter";
				}
			}
			else if (stage == 3) // Boiler
			{
				if (taste == 0) //bitter
				{				
					name = "Bitter Boiler";
				}
				else if (taste == 1) //salty
				{				
					name = "Salty Boiler";
				}
				else if (taste == 2) //sour
				{				
					name = "Sour Boiler";
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet Boiler";
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami Boiler";
				}
			}
			else if (stage == 4) // Fermenter
			{
				if (taste == 0) //bitter
				{				
					name = "Bitter Fermenter";
				}
				else if (taste == 1) //salty
				{				
					name = "Salty Fermenter";
				}
				else if (taste == 2) //sour
				{				
					name = "Sour Fermenter";
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet Fermenter";
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami Fermenter";
				}
			}
			else if (stage == 5) // Bottler
			{
				if (taste == 0) //bitter
				{				
					name = "Bitter Bottler";
				}
				else if (taste == 1) //salty
				{				
					name = "Salty Bottler";
				}
				else if (taste == 2) //sour
				{				
					name = "Sour Bottler";
				}
				else if (taste == 3) //sweet
				{				
					name = "Sweet Bottler";
				}			
				else if (taste == 4) //umami
				{				
					name = "Umami Bottler";
				}
			}			
			*/
		}
	}	
}