﻿package  
{
	import mx.collections.ArrayCollection;
	import Visual.GameSprite;
	
	/**
	 * ...
	 * @author Nicki T. Hansen
	 */
	public class OutputMachine 
	{
		public var sprite:GameSprite;
		public var beers:ArrayCollection = new ArrayCollection();
		public var soldBeerValue:Number = 0;
		public var incomePerSec:Number = 0;
		public var perfectFlavor:Array = [0, 0, 0, 0, 0]//bitter, salty, sour, sweet, umami
		
		public function OutputMachine() 
		{
			sprite = new GameSprite( -1, -2, false);			
			generatePerfectFlavor();
			
			//FIXME remove trace
			//trace(perfectFlavor[0] + "*Bitter, " + perfectFlavor[1] + "*salty, " + perfectFlavor[2] + "*sour, " + 
			//perfectFlavor[3] +  "*sweet, " + perfectFlavor[4] + " umami");
		}
		
		public function addBeer(beer:Beer):void
		{
			beers.addItem(beer);			
		}
		
		public function generatePerfectFlavor():void
		{
			var budget:Number = 6;
			
			while (budget > 0)
			{
				var taste:Number = Math.floor(Math.random() * 5);
				perfectFlavor[taste] = perfectFlavor[taste] +  1;
				budget--;				
			}			
		}
		
		public function sellBeer():Number
		{
			if (beers.length != 0)
			{
				var beer:Beer = Beer(beers.getItemAt(0));
				
				soldBeerValue += findPrice(beer);
				beers.removeItemAt(0);
			}
			
			var tmp:Number = soldBeerValue;
			soldBeerValue = 0;
			return tmp;
		}
		
		private function findPrice(beer:Beer):Number
		{
			//trace(beer.completedStage);
			var avgQuality:Number = beer.qualitySummed / beer.completedStage;
			var optimalBasePrice:Number = beer.completedStage * 5 + 5;
			var tasteDifferential:Number = 0;
			//TODO add optimalValue per stage
			
			tasteDifferential += Math.abs(beer.bitter - perfectFlavor[0]);
			tasteDifferential += Math.abs(beer.salty - perfectFlavor[1]);
			tasteDifferential += Math.abs(beer.sour - perfectFlavor[2]);
			tasteDifferential += Math.abs(beer.sweet - perfectFlavor[3]);
			tasteDifferential += Math.abs(beer.umami - perfectFlavor[4]);
			
			var price:Number = optimalBasePrice - tasteDifferential;
			
			price = Math.round(price * avgQuality);
			return price;
			
		}
	}
	
}