﻿package Visual 
{
	import flash.filters.*;
	import flash.display.*;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import mx.controls.Image;
	import mx.core.*;
	import mx.containers.*;
	
	/**
	 * ...
	 * @author Nicki Thomas Hansen
	 */
	public class GameSprite extends Image
	{
		//public var graphicStates:Array = null; //index 0 = unselected, 1= selected
		private var gr:GraphicsResource;
		protected var selected:Boolean = false; 
		
		public var locked:Boolean = false;
		public var rankImage:Image;
		public var stageImage:Image;
		public var rank:Number = 0;
		
		public var isMachine:Boolean = false;
		public var isInput:Boolean = false;
		public var isOutput:Boolean = false;
		
		public function GameSprite(taste:Number, stage:Number, select:Boolean)
		{
			//	associatedMachine = machine;
			setMachineGraphics(stage, taste);			
			if (stage < 0)
			{
				if (stage == -1) isInput = true;
				if (stage == -2) isOutput = true;
				locked = true;
			}
			else
			{
				setStage(stage);
				isMachine = true;
				selected = select;
			}
			
			
			drawMe();
		}
		
		
		
		public function changeSelection(select:Boolean):void
		{
			selected = select;			
			drawMe();
		}
		public function lock():void
		{
			locked = true;
		}
		public function drawMe():void
		{
			this.graphics.clear();
			this.mouseChildren = false;
			this.height = gr.sprite.height;
			this.width = gr.sprite.width;			
			
			//TODO vær grøn hvis ikke sat endnu ellers billede
			this.graphics.beginBitmapFill(gr.sprite);
			this.graphics.drawRect(0, 0, (this.width), (this.height));
			this.graphics.endFill();
			this.addEventListener(MouseEvent.MOUSE_OVER, mouseOverHandler);
			this.addEventListener(MouseEvent.MOUSE_OUT, mouseOutHandler);
			if (isMachine)
			{
				if (selected)
				{
					this.graphics.lineStyle(2, 0xFFeeeeee);
					this.graphics.drawRoundRect(0, 0, this.width, this.height, 20, 20);
					
				}else
				{
					this.graphics.lineStyle(2, 0xFF666666);
					this.graphics.drawRoundRect(0, 0, this.width, this.height, 20, 20);				
				}
			}
		}
		
		/*
		 * Changes type and initializes bitmaps
		 * type == taste
		 *  skulle hedde "setType"
		 */
		private function setMachineGraphics(stage:Number, taste:Number):void
		{
			if (stage < 0)
			{
				if (stage == -1) gr = Resource.inputGR;
				if (stage == -2) gr = Resource.outputGR;
			}
			else
			{
				gr = Resource.machineArray[stage][taste];
			}
			
		}
		private function setStage(stage:Number):void
		{
			stage = stage + 1;
			if (stage == 1)
			{
				addStageImage(Resource.stage1GR);
			}else if (stage == 2 )
			{
				addStageImage(Resource.stage2GR);
			}else if (stage == 3 )
			{
				addStageImage(Resource.stage3GR);
			}else if (stage == 4 )
			{
				addStageImage(Resource.stage4GR);
			}else if (stage == 5 )
			{
				addStageImage(Resource.stage5GR);
			}else if (stage == 6 )
			{
				addStageImage(Resource.stage6GR);
			}
		}
		
		//redundant med move, meh.
		public function setStartPosition(x:Number, y:Number):void
		{
			this.move(x, y);
		}		
		
		public function upgrade():void
		{
			//trace("upgrade");
			if (rank == 0)
			{				
				addRankImage(Resource.veteran1GR);
				rank = 1;				
			}
			else 
			{							
				if (rank == 1)
				{
					addRankImage(Resource.veteran2GR);
					rank = 2;
				}
				else if (rank == 2)
				{
					addRankImage(Resource.veteran3GR);
					rank = 3;
				}
				else if (rank == 3)
				{
					addRankImage(Resource.veteran4GR);
					rank = 4;
				}
			}			
		}
		private function addRankImage(gr:GraphicsResource):void
		{			
			if (rankImage != null) this.removeChild(rankImage);
			rankImage = new Image();
			rankImage.graphics.beginBitmapFill(gr.sprite, null, false, true);
			rankImage.graphics.drawRect(0, 0, gr.sprite.width, gr.sprite.height);
			rankImage.graphics.endFill();				
			rankImage.scaleX = 0.3;
			rankImage.scaleY = 0.3;
			rankImage.move(gr.sprite.width-(rankImage.width+10),0);		
			this.addChild(rankImage);
		}
		
		
		private function addStageImage(gr:GraphicsResource):void
		{
			
			stageImage = new Image();
			stageImage.graphics.beginBitmapFill(gr.sprite, null, false, true);
			stageImage.graphics.drawRect(0, 0, gr.sprite.width, gr.sprite.height);
			stageImage.graphics.endFill();				
			stageImage.scaleX = 0.4;
			stageImage.scaleY = 0.4;
			stageImage.move(5,7);			
			this.addChild(stageImage);
			
		}
		private function mouseOverHandler(event:MouseEvent):void
		{
			var et:GameSprite = GameSprite(event.target);
			et.filters =  [new GlowFilter(0xEEEEEE)];
		}
		private function mouseOutHandler(event:MouseEvent):void
		{
			var et:GameSprite = GameSprite(event.target);
		et.filters = null;
		}
	}	
}